*-----------------------------------------------------------
* Program    : Knights Tour
* Written by : Daniel Daggett
* Date       : 3/31/09
* Description:
*    Starts the Knight off in a random space on the board and 
* attempts to visit every other space on the board. In order 
* to increase its chances the Knight moves to the space with 
* the fewest exit moves available, leaving its self more options 
* towards the end. 
* 
* The speed may be set by pressing 0-9. Speed 0 is "speed mode"
* and will run the simulations a fast as possible only displaying 
* final board outcome. You can slow it down to see what is going 
* on by pressing 1-9 to set a delay which will have the simulator
* display knight and where he has been. By pressing the space bar, 
* you can pause the simulator press it again to advance one move. 
* 
*-----------------------------------------------------------
Timer	MACRO
	MOVE.B	#8,D0
	TRAP	#15
	MOVE.L	D1,\1
	ENDM
	
CalcTime MACRO
	MOVE.L	\2,D1
	SUB.L	\1,D1
	DIVU	#100,D1
        SWAP	D1
	CLR.W	D1
	SWAP	D1 
	MOVE.L	D1,\3
	ENDM
	
MoveCursor MACRO
	MOVEM.L	D0-D1,-(A7)
	CLR.L	D1
	MOVE.B	\2,D1
	LSL	#8,D1
	MOVE.B	\1,D1
	MOVE.L	#11,D0
	TRAP	#15
	MOVEM.L	(A7)+,D0-D1
	ENDM
	
Print	MACRO
	MOVEM.L	D0-D2,-(A7)
	MOVE.L	#Black,D1	; Set Fill to Black
	MOVE.W	#81,D0
	TRAP	#15
	MOVE.L	\1,D1
	MOVE.L	#20,D0
	MOVE.L	#5,D2
	TRAP	#15
	MOVEM.L	(A7)+,D0-D2
	ENDM

PrintPercent MACRO
	MOVEM.L	D0-D2,-(A7)
	MOVE.L	#Black,D1	; Set Fill to Black
	MOVE.W	#81,D0
	TRAP	#15
	MOVE.L	\1,D1
	MOVE.L	#20,D0
	MOVE.L	#3,D2
	TRAP	#15
	MOVEM.L	(A7)+,D0-D2
	ENDM

PrintLine MACRO
	MOVE.L	\2,D1	; Set Fill to Black
	MOVE.W	#81,D0
	TRAP	#15
	MOVEM.L D0/A1,-(A7)
	MOVE.L #14,D0
	LEA	\1,A1
	TRAP	#15
	MOVEM.L	(A7)+,D0/A1
	ENDM


	ORG     $1000
START:  MOVE.L	#12,D0		; Turn off Keyboard Echo
	MOVE.L	#0,D1
	TRAP	#15
	MOVE.L	#16,D0		; Turn off Prompt
	TRAP	#15
	
	move.b  #33,d0    	      ; set window size
	move.l  #(800<<16+600),d1       ; 800 x 600
	trap    #15
	
	MOVE.L	#Navy,D1	; Set Pen color to NAVY
	MOVE.W	#80,D0
	TRAP	#15
	
	MOVE.L	#81,D0		; Set fill color to Navy
	TRAP	#15

	MOVE.L	#87,D0		; Draw a Box on the screen
	MOVE.L	#260,D1
	MOVE.L	#198,D2
	MOVE.L	#506,D3
	MOVE.L	#320,D4
	TRAP	#15
	
        MoveCursor	#14,#35
        PrintLine	DisKnightsTour,#Navy
        MoveCursor	#15,#35
        PrintLine	DisName,#Navy
        MoveCursor      #17,#35
        PrintLine       Instructions,#Navy
        MoveCursor	#20,#35
        PrintLine	DisDate,#Navy

	MOVE.W	#500,SPEED
	MOVE.L	#24,D1
	MOVE.L	#7,D2
	MOVE.L	#2,D0
	BSR	DisKnight
	BSR	Pause
	MOVE.W	#1,SPEED        ; defautl to speed 1

	Timer	StartTr
	MOVE.L	#Navy,D1	; Set Pen color to 
	MOVE.W	#80,D0
	TRAP	#15
	
	MOVE.W	#93,D0		; Set Pen width to 5
	MOVE.L	#5,D1
	TRAP	#15
	
	MOVE.L	#90,D0		; Draw a Boarder around the board
	MOVE.L	#7,D1
	MOVE.L	#7,D2
	MOVE.L	#509,D3
	MOVE.L	#509,D4
	TRAP	#15
	
	MOVE.W	#93,D0		; Set Pen width to 2
	MOVE.L	#2,D1
	TRAP	#15
	
	MOVE.L	#90,D0		; Draw a Boarder around the Stats
	MOVE.L	#560,D1
	MOVE.L	#50,D2
	MOVE.L	#721,D3
	MOVE.L	#172,D4		; Set to 172 for rate or 157 without
	TRAP	#15
	
	MOVE.W	#93,D0		; Set Pen width to 1
	MOVE.L	#1,D1
	TRAP	#15
	
	
	CLR.L	Attempt
	CLR.L	Fail
	CLR.L	Success
	MOVE.L	#64,D7
STARTover
	BSR	DsBrd
	BSR	UpdateStat
	ADDI.L	#1,Attempt
	CMP	#64,D7
	BEQ	FailSkip
	ADDI.L	#1,Fail
FailSkip
	LEA     Board,A1
	CLR.L   D0
	LEA	MovesList,A6
	BSR	BoardClear
	BSR	AccessClear

	MOVE.W  #1,D7

	BSR	random_n
	MOVE.L	D0,D1
	BSR	random_n
	MOVE.L	D0,D2
	MULU.W	#8,D1
	CLR.L	D0
	MOVE.W	D1,D0
	ADD.W	D2,D0
	ADD.L	#$1500,D0
	MOVEA	D0,A1
	ADDI.B	#1,(A1)
*	CLR.L   D1	
*	CLR.L   D2
	BSR	AccessUpdate
	MOVE.L	#1,D0
	BSR	DisKnight
	BSR	Pause
	MOVE	#0,D0
	BSR	DisKnight
	
Again	MOVE.L	D1,-(A7)
	MOVE.L	#7,D0           ; check for keyboard input
	TRAP	#15
	CMP	#0,D1
	BEQ	NoSpeed         ; if no key press
	BSR	SetSpeed	; if key press
NoSpeed	MOVE.L	(A7)+,D1
	BSR	RandomMove
	CMP     #$63,D0         ; if it returns a 99
	BEQ     STARTover
	BSR     MOVE
	CMP     #$63,D0         ; if it returns a 99
	BEQ     STARTover
	
	
	MOVE.B	D0,(A6)		; Stores move in MovesList +n
	ADDA.L	#1,A6
	BSR	AccessUpdate	; Updates Access Table and returns the address of the current space in D0
	MOVEA   D0,A1           ; Moves pointer to the current space into A0
	ADDI.B	#1,(A1)
	ADDA.L	#$40,A1		; Moves pointer to the current space in Access Table and sets it to zero
	MOVE.B	#0,(A1)	
	
	CMPI	#0,Speed
	BEQ	SpeedRun
	MOVE.B	#1,D0	
	BSR	DisKnight
	BSR	Pause
	MOVE	#0,D0
	BSR	DisKnight
	
SpeedRun ADD.B   #1,D7           ; Test to see if you have found all the spaces
	CMP.L   #64,D7
	BEQ     DONE
	BRA	Again
	
DONE    ADDI.L	#1,Success
	BRA	STARTover
	
	MOVE.B  #9,D0
	TRAP	#15		; halt simulator

* Variables and Strings
	ORG	$1500
Board	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

Access	DS.B	64		
AccessMaster
	DC.B	2,3,4,4,4,4,3,2,3,4,6,6,6,6,4,3,4,6,8,8,8,8,6,4,4,6,8,8,8,8,6,4,4,6,8,8,8,8,6,4,4,6,8,8,8,8,6,4,3,4,6,6,6,6,4,3,2,3,4,4,4,4,3,2
BoardBackground
	DC.B	0,1,0,1,0,1,0,1,1,0,1,0,1,0,1,0,0,1,0,1,0,1,0,1,1,0,1,0,1,0,1,0,0,1,0,1,0,1,0,1,1,0,1,0,1,0,1,0,0,1,0,1,0,1,0,1,1,0,1,0,1,0,1,0 * This is the Chess Board Format
MovesArray
	DS.B	8
MovesMaster
	DC.B	0,1,2,3,4,5,6,7
MovesList
	DS.B	63
StartTr	DS.L	1
Stop	DS.L	1
Time	DS.L	1
BestMove
	DS.B	1
BestAccess
	DS.B	1
Header	DC.B	'-------------------',0
Space	DC.B	'              ',0
DisFail	DC.B	'Failed:      ',0
DisSucced
	DC.B	'Successful:  ',0
DisAttempt
	DC.B	'Attempt:     ',0
DisTime	DC.B	'Time:        ',0
DisRate DC.B	'Rate Per Sec:',0
DisRatio
	DC.B	'Success Rate: ',0
Percent DC.B	'%',0

DisKnightsTour
	DC.B	'Knight Tour',0
DisName	DC.B	'Daniel Daggett',0
Instructions
        DC.B    'Speed 0-9, Space to pause',0

DisDate	DC.B	'April 30, 2009     CIS 268',0
Attempt	DC.L	0
Success	DC.L	0
Fail	DC.L	0

CR	EQU	$0D
LF	EQU	$0A
BLACK	EQU	$00000000
BLUE	EQU	$00FF0000 
NAVY	EQU	$00800000
TEAL	EQU	$00808000
GRAY	EQU	$00A0A0A0
WHITE	EQU	$00FFFFFF
SEED	DC.L	$12345678
MOVESET DC.L	$01234567
Horse	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,1,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,1,1,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,1,1,1,1,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,1,1,1,0,0,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.B	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

Speed	DS.W	1
SuccessRatio
	DS.L	1
Rate	DS.L	1

* Subroutines
** Move Subroutine **
MOVE	MOVEM.L	D3-D7,-(A7)	; Receives a dir in D0, as well as row in D1 and COL in D2, Returns Destination in D0, and new row in D1 and new col in D2
	MOVE.L	D1,D3
	MOVE.L	D2,D4
	CMP	#0,D0
	BNE	MOVE1
	SUB.B	#16,D1
	SUB.B	#1,D2
	BRA	TESTMOVE
MOVE1	CMP	#1,D0
	BNE	MOVE2
	SUB.B	#16,D1
	ADD.B	#1,D2
	BRA	TESTMOVE
MOVE2	CMP	#2,D0
	BNE	MOVE3
	SUB.B	#8,D1
	ADD.B	#2,D2
	BRA	TESTMOVE
MOVE3	CMP	#3,D0
	BNE	MOVE4
	ADD.B	#8,D1
	ADD.B	#2,D2
	BRA	TESTMOVE
MOVE4	CMP	#4,D0
	BNE	MOVE5
	ADD.B	#16,D1
	ADD.B	#1,D2
	BRA	TESTMOVE
MOVE5	CMP	#5,D0
	BNE	MOVE6
	ADD.B	#16,D1
	SUB.B	#1,D2
	BRA	TESTMOVE
MOVE6	CMP	#6,D0
	BNE	MOVE7
	ADD.B	#8,D1
	SUB.B	#2,D2
	BRA	TESTMOVE
MOVE7	SUB.B	#8,D1
	SUB.B	#2,D2
	BRA	TESTMOVE

TESTMOVE
	CMP.B	#0,D1		; Test Left edge
	BLT	NOTVAL
	CMP.B	#56,D1		; Test Right edge
	BGT	NOTVAL
	CMP.B	#0,D2		; Test Top edge
	BLT	NOTVAL
	CMP.B	#7,D2		; Test Bottom edge
	BGT	NOTVAL
	CLR.L	D0
	MOVE.W	D1,D0
	ADD.W	D2,D0
	ADD.L	#$1500,D0	; Test to see if the space has been visited before
	MOVEA	D0,A1
	CMP.B	#0,(A1)
	BNE	NOTVAL
	BRA	VALMOVE

NOTVAL	MOVE	D3,D1
	MOVE	D4,D2
	MOVE.L	#99,D0
	BRA	ENDMOVE

VALMOVE	MOVE.B	D2,D0
	ADD.B	D1,D0

ENDMOVE	MOVEM.L	(A7)+,D3-D7
	RTS


** Display Board **
DsBrd	MOVEM.L	D0-D7,-(A7)
	CMPI	#0,Speed
	BNE	DisplayBackground
	LEA	Board,A1
	BRA	DisplayBoard	
DisplayBackground
	LEA	BoardBackground,A1
DisplayBoard
	CLR.L	D6
	MOVE.L	#72,D2
	MOVE.L	#10,D3
	MOVE.L	#10,D4
	MOVE.L	#Black,D1	; Set Pen
	MOVE.W	#80,D0
	TRAP	#15
Repeat	MOVE.B	(A1),D7
	CMP.B	#1,D7
	BGE	DYes
	MOVE.L	#Navy,D1	; Set Fill to Black
	MOVE.W	#81,D0
	TRAP	#15
	BRA	DNo
DYes	MOVE.L	#Blue,D1	; Set Pen to Blue
	MOVE	#81,D0
	TRAP	#15
DNo	MOVE.L	D3,D1		; Set size of Square and increament
	ADD.W	#62,D3
	CMP	#506, D3
	BGT	NextRow
	BRA	ThisRow
NextRow	MOVE.L	#10,D1
	MOVE.L	#72,D3
	ADD	#62,D2
	ADD	#62,D4
ThisRow	MOVE	#87,D0
	TRAP	#15	
	ADD.W	#1,D6		; Increment the address pointer
	CMP.W	#64,D6
	BEQ	FinishDsBrd
	ADDA	#1,A1
	BRA	Repeat
FinishDsBrd
	MOVE.L	#BLACK,D1
	MOVE.L	#81,D0
	TRAP	#15
	MOVEM.L	(A7)+,D0-D7
	RTS
	
**Random Number Generator**     
random_n
	MOVEM.L D1-D2,-(sp)                     * save d1 and d2
	MOVE.L	SEED,d0                 * get current seed longword
	MOVEQ           #$AF-$100,d1            * set EOR value
	MOVEQ           #18,d2                  * do this 19 times
Ninc0
	ADD.l           d0,d0                           * shift left 1 bit
	BCC.s           Ninc1                           * if bit not set skip feedback

	EOR.b           d1,d0                           * do Galois LFSR feedback
Ninc1
	DBF             d2,Ninc0                        * loop
	MOVE.L	D0,SEED                 * save back to seed longword
	MOVE.W	#0,D0
	SWAP	D0
	DIVU.W  #8,D0
	MOVE.W  #0,D0
	SWAP    D0
	MOVEM.L	(sp)+,D1-D2                     * restore d1 and d2
	RTS

**Clear the Board**
BoardClear
	MOVEM.L	D1,-(A7)
	LEA	Board,A1
	MOVE.B	#0,(A1)
BCnext	ADDA    #1,A1
	ADD.B   #1,D0
	MOVE.B  #0,(A1)
	CMP.B   #63,D0
	BNE     BCnext
	MOVEM.L	(A7)+,D1
	RTS

**Clear Access Table**
AccessClear
	MOVEM.L	D0/A1-A2,-(A7)
	LEA	Access,A1
	LEA	AccessMaster,A2
	MOVE.W	#1,D0
ACnext	MOVE.B	(A2),(A1)
	ADD.W	#1,D0
	CMP.W	#65,D0
	BEQ	ACEnd
	ADDA	#1,A1
	ADDA	#1,A2
	BRA	ACnext
ACEnd	MOVEM.L	(A7)+,D0/A1-A2
	RTS
	
** Access Table Update Subroutine **
AccessUpdate
	MOVEM.L	D1-D7,-(A7)
*Move 0
	MOVE.B	D1,D3
	MOVE.B	D2,D4
	SUB.B	#16,D1
	SUB.B	#1,D2
	BSR	WriteAccessUpdate
*Move 1
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	SUB.B	#16,D1
	ADD.B	#1,D2
	BSR	WriteAccessUpdate
*Move 2	
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	SUB.B	#8,D1
	ADD.B	#2,D2
	BSR	WriteAccessUpdate
*Move 3	
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	ADD.B	#8,D1
	ADD.B	#2,D2
	BSR	WriteAccessUpdate
*Move 4	
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	ADD.B	#16,D1
	ADD.B	#1,D2
	BSR	WriteAccessUpdate
*Move 5	
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	ADD.B	#16,D1
	SUB.B	#1,D2
	BSR	WriteAccessUpdate
*Move 6	
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	ADD.B	#8,D1
	SUB.B	#2,D2
	BSR	WriteAccessUpdate
*Move 7	
	MOVE.B	D3,D1
	MOVE.B	D4,D2
	SUB.B	#8,D1
	SUB.B	#2,D2
	MOVEM.L	(A7)+,D1-D7
	RTS

**WriteAccessUpdate
WriteAccessUpdate
	MOVEM.L	A0,-(A7)
	CMP.B	#0,D1		; Test Left edge
	BLT	ACnotval
	CMP.B	#56,D1		; Test Right edge
	BGT	ACnotval
	CMP.B	#0,D2		; Test Top edge
	BLT	ACnotval
	CMP.B	#7,D2		; Test Bottom edge
	BGT	ACnotvaL
	LEA	Access,A0
	ADDA.L	D1,A0
	ADDA.L	D2,A0
	CMP.B	#0,(A0)
	BEQ	ACnotval
	SUBI.B	#1,(A0)
ACnotval
	MOVEM.L	(A7)+,A0

	RTS
	
** Find a random move that has the lowest access number **
RandomMove
	MOVEM.L	D1-D7,-(A7)
	CLR.L	D3
	CLR.L	D7
	MOVE.L	MOVESET,D4
	MOVE.L	#16,D5
RMloop	BSR	random_n
	MOVE.B	D0,D3
	MULU.W	#4,D3
	MOVE.B	D4,D7
	AND.B	#%00001111,D7
	SUB.B	D7,D4

	ROL.L	D3,D4
	SWAP	D7
	MOVE.B	D4,D7
	AND.B	#%00001111,D7
	SUB.B	D7,D4
	SWAP	D7
	ADD.B	D7,D4
	SWAP	D7

	ROR.L	D3,D4
	ADD.B	D7,D4
	
	SUBI.W	#1,D5
	BEQ	RMend
	BRA	RMloop	
	CLR.L	D5
RMend	
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip1
	ADDI.B	#$F,D5
	BRA	RMmSkip1
RMdSkip1
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip1
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	*MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip2
	ADDI.B	#$F,D5
	BRA	RMmSkip2
RMdSkip2	
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip2
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	*MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip3	
	ADDI.B	#$F,D5
	BRA	RMmSkip3
RMdSkip3
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip3
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	*MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip4	
	ADDI.B	#$F,D5
	BRA	RMmSkip4
RMdSkip4
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip4
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	*MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip5
	ADDI.B	#$F,D5
	BRA	RMmSkip5
RMdSkip5
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip5
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	*MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip6
	ADDI.B	#$F,D5
	BRA	RMmSkip6
RMdSkip6
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip6
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	*MOVEM.L	D1-D2,-(A7)
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip7
	ADDI.B	#$F,D5
	BRA	RMmSkip7
RMdSkip7
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip7
	MOVEM.L	(A7),D1-D2
	ROL.L	#4,D5
	ROL.L	#4,D4
	CLR.L	D0
	MOVE.B	D4,D0
	AND.B	#%00001111,D0
	BSR	MOVE
	
	CMP.B	#$63,D0
	BNE	RMdSkip8
	ADDI.B	#$F,D5
	BRA	RMmSkip8
RMdSkip8
	LEA	Access,A3
	ADDA.L	D1,A3
	ADDA.L	D2,A3
	ADD.B	(A3),D5
RMmSkip8
	MOVEM.L	(A7)+,D1-D2
	CLR.L	D3
	CLR.L	D6
	CLR.L	D7
	MOVE.B	#0,BestMove
	MOVE.B	#8,BestAccess
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip1
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip1	
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip2
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip2
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip3
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip3
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip4
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip4
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip5
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip5
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip6
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip6
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip7
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip7
	ROL.L	#4,D4
	ROL.L	#4,D5
	MOVE.B	D4,D6
	MOVE.B	D5,D7
	AND.B	#%00001111,D6
	AND.B	#%00001111,D7
	CMP.B	BestAccess,D7
	BGE	RMaSkip8
	MOVE.B	D6,BestMove
	MOVE.B	D7,BestAccess
RMaSkip8
	CLR.L	D0
	MOVE.B	#$63,D0
	CMP.B	#$F,BestAccess
	BEQ	RME
	MOVE.B	BestMove,D0
	
RME	MOVEM.L	(A7)+,D1-D7
	RTS
	
** Update The Stats **
UpdateStat
	MOVEM.L	D0-D7,-(A7)
  MoveCursor	#4,#71
   PrintLine	DisFail,#Black
       Print	Fail
  MoveCursor	#5,#71
   PrintLine	DisSucced,#Black
       Print	Success
  MoveCursor	#6,#71
   PrintLine	DisAttempt,#Black
       Print	Attempt
      MOVE.L	Success,D0
      MOVE.L	Attempt,D1
*        CMPI	#270,D1
*         BGT	UpdateSkip
        CMPI	#0,D1
         BEQ	UpdateSkip
         
DisAttemptOverTimeTryAgain
        CMPI	#270,D1
         BLT	DisAttemptOverTime
         ASR	#1,D1
         ASR	#1,D0
         BRA	DisAttemptOverTimeTryAgain
         
DisAttemptOverTime
      MOVE.L	#10000,D2
      DIVU.W	D1,D2
      MULU.W	D2,D0
      DIVU.W	#100,D0
      MOVE.L	D0,D1
        SWAP	D1
       CLR.W	D1
        SWAP	D1
        Move.L	D1,SuccessRatio
UpdateSkip
  MoveCursor	#9,#71 
   PrintLine	DisRatio,#Black
 PrintPercent 	SuccessRatio
   PrintLine	Percent,#Black
  MoveCursor	#7,#71
   PrintLine	DisTime,#Black
       Timer	Stop
    CalcTime	StartTr, Stop, Time 
       Print	Time
      MOVE.L	Time,D1
         CMP	#0,D1
         BEQ	UpdateSkip2
      MOVE.L	Attempt,D0
      DIVU.W	D1,D0
      SWAP	D0
      CLR.W	D0
      SWAP	D0
      MOVE.L	D0,Rate
  MoveCursor	#10,#71
   PrintLine	DisRate,#Black
       Print	Rate
UpdateSkip2	
     MOVEM.L	(A7)+,D0-D7
	 RTS
	 
** Display Knight **
DisKnight
	CMPI	#0,Speed
	BEQ	DKSpeedSkip
	MOVEM.L	D0-D7,-(A7)     ; Recives Row D1 Col D2
				; Paints X D1, Y D2
	LEA	Horse,A3	; Store in D5 Fill State	
	MOVE.L	D2,D3
	MOVE.L	D1,D2
	MOVE.L	D0,D5
	MOVE.L	#80,D0
	MOVE.L	#BLACK,D1
	TRAP	#15
	DIVU.W	#8,D2
	MULU.W	#62,D2
	MULU.W	#62,D3
	ADDI.W	#19,D2
	ADDI.W	#16,D3
	MOVE.L	D3,D1
	ADDI.W	#50,D3		; D3 now holds the X just past the edge of the horse
	CLR	D4		; D4 Will count how many times we go through the pixels
DkLoop	MOVE.B	(A3),D0
	CMP	#0,D0
	BEQ	DKskip
	MOVE.W	#82,D0
	TRAP	#15
DKskip	ADDA	#1,A3
	ADDI.W	#1,D4
	ADDI.W	#1,D1
	CMP	D1,D3
	BEQ	DKrowRest
	BRA	DkLoop
DKrowRest
	CMP	#2250,D4
	BEQ	DKdone
	ADDI.W	#1,D2
	SUBI.W	#50,D1
	BRA	DkLoop
DKdone	CMP	#0,D5
	BEQ	DKgray
	MOVE.L	#WHITE,D1
	BRA	DKfill
DKgray	MOVE.L	#GRAY,D1
DKfill	MOVE.L	#81,D0
	TRAP #15
	MOVE.L	D3,D1
	SUBI.W	#10,D1
	SUBI.W	#10,D2
	MOVE.L	#89,D0
	TRAP	#15
	MOVE.L	#BLACK,D1
	MOVE.L	#81,D0
	TRAP	#15

	MOVEM.L (A7)+,D0-D7
DKSpeedSkip	
	RTS

** PAUSE **
Pause	MOVEM.L	D0-D2,-(A7)
	MOVE.W	Speed,D2
	CMP	#$FFFF,D2
	BNE	NoRealyPause
	BSR	SetSpeed
	BRA	Pdone
NoRealyPause
	MOVE.L	#8,D0
	TRAP	#15
	ADD.L	D1,D2
Prepeat	TRAP	#15
	CMP	D1,D2
	BLT	Pdone
	BRA	Prepeat
Pdone	MOVEM.L	(A7)+,D0-D2
	RTS
	
** SetSpeed**
SetSpeed MOVEM.L D0-D1,-(A7)
	MOVE.L	#5,D0           ; read ASCII character in D1.B
	TRAP	#15
	CMP	#$20,D1         ; if space
	BEQ	SetPause
	CMP	#'0',D1
	BLT	SSdone          ; if < 0
	CMP	#'9',D1
	BGT	SSdone          ; if > 9
	SUBI	#$30,D1         ; convert ASCII to digit
	MOVE.W	D1,D0
	MULU.W	D0,D1
	MOVE.W	D1,Speed
	BRA	SSdone
SetPause MOVE.W	#$FFFF,Speed	
SSdone	MOVEM.L	(A7)+,D0-D1
	RTS
	
	END	START		; last line of source




*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
